"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Curation(ProtocolElement):
    """
    The curation record contains all information that might be stored from
    a curation event.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "automaticConsistencyStatus",
        "heritableTrait",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "additionalProperties": reports_6_9_0.Property,
            "genomicFeature": reports_6_9_0.GenomicFeature,
            "heritableTrait": reports_6_9_0.HeritableTrait,
            "variantClassification": reports_6_9_0.VariantClassification,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import participant as participant_1_5_0
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "assembly": reports_6_9_0.Assembly,
            "automaticConsistencyStatus": reports_6_9_0.ConsistencyStatus,
            "confidence": reports_6_9_0.Confidence,
            "manualConsistencyStatus": reports_6_9_0.ConsistencyStatus,
            "penetrance": participant_1_5_0.Penetrance,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import cva as cva_1_5_3
        from protocols.protocol_8_8 import opencb as opencb_2_9_3
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "org.opencb.biodata.models.variant.avro.Property": opencb_2_9_3.Property,
            "org.gel.models.report.avro.Assembly": reports_6_9_0.Assembly,
            "org.opencb.biodata.models.variant.avro.ConsistencyStatus": opencb_2_9_3.ConsistencyStatus,
            "org.opencb.biodata.models.variant.avro.Confidence": opencb_2_9_3.Confidence,
            "org.opencb.biodata.models.variant.avro.GenomicFeature": opencb_2_9_3.GenomicFeature,
            "org.opencb.biodata.models.variant.avro.HeritableTrait": opencb_2_9_3.HeritableTrait,
            "org.opencb.biodata.models.variant.avro.ConsistencyStatus": opencb_2_9_3.ConsistencyStatus,
            "org.opencb.biodata.models.variant.avro.Penetrance": opencb_2_9_3.Penetrance,
            "org.opencb.biodata.models.variant.avro.VariantClassification": opencb_2_9_3.VariantClassification,
            "org.gel.models.cva.avro.Curation": cva_1_5_3.Curation,
        }

    __slots__ = [
        "automaticConsistencyStatus",
        "heritableTrait",
        "actionable",
        "additionalProperties",
        "assembly",
        "bibliography",
        "confidence",
        "confirmed",
        "genomicFeature",
        "manualConsistencyStatus",
        "penetrance",
        "reportableAsSecondaryFinding",
        "variableExpressivity",
        "variantClassification",
    ]

    def __init__(
        self,
        automaticConsistencyStatus,
        heritableTrait,
        actionable=None,
        additionalProperties=list,
        assembly=None,
        bibliography=list,
        confidence=None,
        confirmed=None,
        genomicFeature=None,
        manualConsistencyStatus=None,
        penetrance=None,
        reportableAsSecondaryFinding=None,
        variableExpressivity=None,
        variantClassification=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.Curation model.

        :param automaticConsistencyStatus:
            The automatic consistency status. The value is automatically inferred
            from evidences.
        :type automaticConsistencyStatus: ConsistencyStatus
        :param heritableTrait:
            The heritable phenotype to which the curation refers.
        :type heritableTrait: HeritableTrait
        :param actionable:
            Is this variant actionable?
        :type actionable: None | boolean
        :param additionalProperties:
            A list of additional properties in the form name-value.
        :type additionalProperties: list[Property]
        :param assembly:
            The assembly to which the curation refers
        :type assembly: None | Assembly
        :param bibliography:
            Bibliography
        :type bibliography: list[str]
        :param confidence:
            The curation confidence.
        :type confidence: None | Confidence
        :param confirmed:
            Confirmation flag to support two-step curation
        :type confirmed: None | boolean
        :param genomicFeature:
            The transcript to which the curation refers
        :type genomicFeature: None | GenomicFeature
        :param manualConsistencyStatus:
            The manual consistency status. The value is optionally provided by a
            curator.
        :type manualConsistencyStatus: None | ConsistencyStatus
        :param penetrance:
            The penetrance of the phenotype for this genotype. Value in the range
            [0, 1]
        :type penetrance: None | Penetrance
        :param reportableAsSecondaryFinding:
            Can this variant be reported as a secondary finding?
        :type reportableAsSecondaryFinding: None | boolean
        :param variableExpressivity:
            Variable expressivity of a given phenotype for the same genotype
        :type variableExpressivity: None | boolean
        :param variantClassification:
            The variant's classification.
        :type variantClassification: None | VariantClassification
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
